# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

import msrest.serialization


class AadIdentifier(msrest.serialization.Model):
    """AadIdentifier.

    :param email_id:
    :type email_id: str
    :param object_id:
    :type object_id: str
    :param tenant_id:
    :type tenant_id: str
    :param puid:
    :type puid: str
    """

    _attribute_map = {
        'email_id': {'key': 'emailId', 'type': 'str'},
        'object_id': {'key': 'objectId', 'type': 'str'},
        'tenant_id': {'key': 'tenantId', 'type': 'str'},
        'puid': {'key': 'puid', 'type': 'str'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(AadIdentifier, self).__init__(**kwargs)
        self.email_id = kwargs.get('email_id', None)
        self.object_id = kwargs.get('object_id', None)
        self.tenant_id = kwargs.get('tenant_id', None)
        self.puid = kwargs.get('puid', None)


class FulfillmentInternalServerErrorResponse(msrest.serialization.Model):
    """FulfillmentInternalServerErrorResponse.

    :param error:
    :type error: ~microsoft.marketplace.saas.models.FulfillmentInternalServerErrorResponseError
    """

    _attribute_map = {
        'error': {'key': 'error', 'type': 'FulfillmentInternalServerErrorResponseError'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(FulfillmentInternalServerErrorResponse, self).__init__(**kwargs)
        self.error = kwargs.get('error', None)


class FulfillmentInternalServerErrorResponseError(msrest.serialization.Model):
    """FulfillmentInternalServerErrorResponseError.

    :param code:
    :type code: str
    :param message:
    :type message: str
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'message': {'key': 'message', 'type': 'str'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(FulfillmentInternalServerErrorResponseError, self).__init__(**kwargs)
        self.code = kwargs.get('code', None)
        self.message = kwargs.get('message', None)


class Operation(msrest.serialization.Model):
    """Operation.

    :param id:
    :type id: str
    :param activity_id:
    :type activity_id: str
    :param subscription_id:
    :type subscription_id: str
    :param offer_id:
    :type offer_id: str
    :param publisher_id:
    :type publisher_id: str
    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: int
    :param action:  Possible values include: "Unsubscribe", "ChangePlan", "ChangeQuantity",
     "Suspend", "Reinstate".
    :type action: str or ~microsoft.marketplace.saas.models.OperationActionEnum
    :param time_stamp:
    :type time_stamp: ~datetime.datetime
    :param status:  Possible values include: "NotStarted", "InProgress", "Succeeded", "Failed",
     "Conflict".
    :type status: str or ~microsoft.marketplace.saas.models.OperationStatusEnum
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'activity_id': {'key': 'activityId', 'type': 'str'},
        'subscription_id': {'key': 'subscriptionId', 'type': 'str'},
        'offer_id': {'key': 'offerId', 'type': 'str'},
        'publisher_id': {'key': 'publisherId', 'type': 'str'},
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'int'},
        'action': {'key': 'action', 'type': 'str'},
        'time_stamp': {'key': 'timeStamp', 'type': 'iso-8601'},
        'status': {'key': 'status', 'type': 'str'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(Operation, self).__init__(**kwargs)
        self.id = kwargs.get('id', None)
        self.activity_id = kwargs.get('activity_id', None)
        self.subscription_id = kwargs.get('subscription_id', None)
        self.offer_id = kwargs.get('offer_id', None)
        self.publisher_id = kwargs.get('publisher_id', None)
        self.plan_id = kwargs.get('plan_id', None)
        self.quantity = kwargs.get('quantity', None)
        self.action = kwargs.get('action', None)
        self.time_stamp = kwargs.get('time_stamp', None)
        self.status = kwargs.get('status', None)


class OperationList(msrest.serialization.Model):
    """OperationList.

    :param operations:
    :type operations: list[~microsoft.marketplace.saas.models.Operation]
    """

    _attribute_map = {
        'operations': {'key': 'operations', 'type': '[Operation]'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(OperationList, self).__init__(**kwargs)
        self.operations = kwargs.get('operations', None)


class Plan(msrest.serialization.Model):
    """Plan.

    :param plan_id:
    :type plan_id: str
    :param display_name:
    :type display_name: str
    :param is_private:
    :type is_private: bool
    """

    _attribute_map = {
        'plan_id': {'key': 'planId', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'is_private': {'key': 'isPrivate', 'type': 'bool'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(Plan, self).__init__(**kwargs)
        self.plan_id = kwargs.get('plan_id', None)
        self.display_name = kwargs.get('display_name', None)
        self.is_private = kwargs.get('is_private', None)


class ResolvedSubscription(msrest.serialization.Model):
    """Summary of the subscription.

    :param id:
    :type id: str
    :param subscription_name:
    :type subscription_name: str
    :param offer_id:
    :type offer_id: str
    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: long
    :param subscription:
    :type subscription: ~microsoft.marketplace.saas.models.Subscription
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'subscription_name': {'key': 'subscriptionName', 'type': 'str'},
        'offer_id': {'key': 'offerId', 'type': 'str'},
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'long'},
        'subscription': {'key': 'subscription', 'type': 'Subscription'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(ResolvedSubscription, self).__init__(**kwargs)
        self.id = kwargs.get('id', None)
        self.subscription_name = kwargs.get('subscription_name', None)
        self.offer_id = kwargs.get('offer_id', None)
        self.plan_id = kwargs.get('plan_id', None)
        self.quantity = kwargs.get('quantity', None)
        self.subscription = kwargs.get('subscription', None)


class SubscriberPlan(msrest.serialization.Model):
    """SubscriberPlan.

    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: long
    """

    _attribute_map = {
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'long'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(SubscriberPlan, self).__init__(**kwargs)
        self.plan_id = kwargs.get('plan_id', None)
        self.quantity = kwargs.get('quantity', None)


class Subscription(msrest.serialization.Model):
    """Subscription.

    :param id:
    :type id: str
    :param publisher_id:
    :type publisher_id: str
    :param offer_id:
    :type offer_id: str
    :param name:
    :type name: str
    :param saas_subscription_status: Indicates the status of the operation. Possible values
     include: "NotStarted", "PendingFulfillmentStart", "Subscribed", "Suspended", "Unsubscribed".
    :type saas_subscription_status: str or
     ~microsoft.marketplace.saas.models.SubscriptionStatusEnum
    :param beneficiary:
    :type beneficiary: ~microsoft.marketplace.saas.models.AadIdentifier
    :param purchaser:
    :type purchaser: ~microsoft.marketplace.saas.models.AadIdentifier
    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: int
    :param term:
    :type term: ~microsoft.marketplace.saas.models.SubscriptionTerm
    :param is_test: Indicating whether the current subscription is a test asset.
    :type is_test: bool
    :param is_free_trial: true - the customer subscription is currently in free trial, false - the
     customer subscription is not currently in free trial.(optional field - default false).
    :type is_free_trial: bool
    :param allowed_customer_operations:
    :type allowed_customer_operations: list[str or
     ~microsoft.marketplace.saas.models.AllowedCustomerOperationsEnum]
    :param session_id:
    :type session_id: str
    :param fulfillment_id:
    :type fulfillment_id: str
    :param store_front:
    :type store_front: str
    :param session_mode: Dry Run indicates all transactions run as Test-Mode in the commerce stack.
     Possible values include: "None", "DryRun".
    :type session_mode: str or ~microsoft.marketplace.saas.models.SessionModeEnum
    :param sandbox_type: Possible Values are None, Csp (Csp sandbox purchase). Possible values
     include: "None", "Csp".
    :type sandbox_type: str or ~microsoft.marketplace.saas.models.SandboxTypeEnum
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'publisher_id': {'key': 'publisherId', 'type': 'str'},
        'offer_id': {'key': 'offerId', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'saas_subscription_status': {'key': 'saasSubscriptionStatus', 'type': 'str'},
        'beneficiary': {'key': 'beneficiary', 'type': 'AadIdentifier'},
        'purchaser': {'key': 'purchaser', 'type': 'AadIdentifier'},
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'int'},
        'term': {'key': 'term', 'type': 'SubscriptionTerm'},
        'is_test': {'key': 'isTest', 'type': 'bool'},
        'is_free_trial': {'key': 'isFreeTrial', 'type': 'bool'},
        'allowed_customer_operations': {'key': 'allowedCustomerOperations', 'type': '[str]'},
        'session_id': {'key': 'sessionId', 'type': 'str'},
        'fulfillment_id': {'key': 'fulfillmentId', 'type': 'str'},
        'store_front': {'key': 'storeFront', 'type': 'str'},
        'session_mode': {'key': 'sessionMode', 'type': 'str'},
        'sandbox_type': {'key': 'sandboxType', 'type': 'str'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(Subscription, self).__init__(**kwargs)
        self.id = kwargs.get('id', None)
        self.publisher_id = kwargs.get('publisher_id', None)
        self.offer_id = kwargs.get('offer_id', None)
        self.name = kwargs.get('name', None)
        self.saas_subscription_status = kwargs.get('saas_subscription_status', None)
        self.beneficiary = kwargs.get('beneficiary', None)
        self.purchaser = kwargs.get('purchaser', None)
        self.plan_id = kwargs.get('plan_id', None)
        self.quantity = kwargs.get('quantity', None)
        self.term = kwargs.get('term', None)
        self.is_test = kwargs.get('is_test', None)
        self.is_free_trial = kwargs.get('is_free_trial', None)
        self.allowed_customer_operations = kwargs.get('allowed_customer_operations', None)
        self.session_id = kwargs.get('session_id', None)
        self.fulfillment_id = kwargs.get('fulfillment_id', None)
        self.store_front = kwargs.get('store_front', None)
        self.session_mode = kwargs.get('session_mode', None)
        self.sandbox_type = kwargs.get('sandbox_type', None)


class SubscriptionPlans(msrest.serialization.Model):
    """SubscriptionPlans.

    :param plans:
    :type plans: list[~microsoft.marketplace.saas.models.Plan]
    """

    _attribute_map = {
        'plans': {'key': 'plans', 'type': '[Plan]'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(SubscriptionPlans, self).__init__(**kwargs)
        self.plans = kwargs.get('plans', None)


class SubscriptionsResponse(msrest.serialization.Model):
    """SubscriptionsResponse.

    :param subscriptions:
    :type subscriptions: list[~microsoft.marketplace.saas.models.Subscription]
    :param next_link: Link to get the next set of subscriptions.
    :type next_link: str
    """

    _attribute_map = {
        'subscriptions': {'key': 'subscriptions', 'type': '[Subscription]'},
        'next_link': {'key': '@nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(SubscriptionsResponse, self).__init__(**kwargs)
        self.subscriptions = kwargs.get('subscriptions', None)
        self.next_link = kwargs.get('next_link', None)


class SubscriptionTerm(msrest.serialization.Model):
    """SubscriptionTerm.

    :param start_date:
    :type start_date: ~datetime.datetime
    :param end_date:
    :type end_date: ~datetime.datetime
    """

    _attribute_map = {
        'start_date': {'key': 'startDate', 'type': 'iso-8601'},
        'end_date': {'key': 'endDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(SubscriptionTerm, self).__init__(**kwargs)
        self.start_date = kwargs.get('start_date', None)
        self.end_date = kwargs.get('end_date', None)


class UpdateOperation(msrest.serialization.Model):
    """UpdateOperation.

    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: long
    :param status:  Possible values include: "Success", "Failure".
    :type status: str or ~microsoft.marketplace.saas.models.UpdateOperationStatusEnum
    """

    _attribute_map = {
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'long'},
        'status': {'key': 'status', 'type': 'str'},
    }

    def __init__(
        self,
        **kwargs
    ):
        super(UpdateOperation, self).__init__(**kwargs)
        self.plan_id = kwargs.get('plan_id', None)
        self.quantity = kwargs.get('quantity', None)
        self.status = kwargs.get('status', None)
