# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

import datetime
from typing import List, Optional, Union

import msrest.serialization

from ._saa_sapi_enums import *


class AadIdentifier(msrest.serialization.Model):
    """AadIdentifier.

    :param email_id:
    :type email_id: str
    :param object_id:
    :type object_id: str
    :param tenant_id:
    :type tenant_id: str
    :param puid:
    :type puid: str
    """

    _attribute_map = {
        'email_id': {'key': 'emailId', 'type': 'str'},
        'object_id': {'key': 'objectId', 'type': 'str'},
        'tenant_id': {'key': 'tenantId', 'type': 'str'},
        'puid': {'key': 'puid', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        email_id: Optional[str] = None,
        object_id: Optional[str] = None,
        tenant_id: Optional[str] = None,
        puid: Optional[str] = None,
        **kwargs
    ):
        super(AadIdentifier, self).__init__(**kwargs)
        self.email_id = email_id
        self.object_id = object_id
        self.tenant_id = tenant_id
        self.puid = puid


class FulfillmentInternalServerErrorResponse(msrest.serialization.Model):
    """FulfillmentInternalServerErrorResponse.

    :param error:
    :type error: ~microsoft.marketplace.saas.models.FulfillmentInternalServerErrorResponseError
    """

    _attribute_map = {
        'error': {'key': 'error', 'type': 'FulfillmentInternalServerErrorResponseError'},
    }

    def __init__(
        self,
        *,
        error: Optional["FulfillmentInternalServerErrorResponseError"] = None,
        **kwargs
    ):
        super(FulfillmentInternalServerErrorResponse, self).__init__(**kwargs)
        self.error = error


class FulfillmentInternalServerErrorResponseError(msrest.serialization.Model):
    """FulfillmentInternalServerErrorResponseError.

    :param code:
    :type code: str
    :param message:
    :type message: str
    """

    _attribute_map = {
        'code': {'key': 'code', 'type': 'str'},
        'message': {'key': 'message', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        code: Optional[str] = None,
        message: Optional[str] = None,
        **kwargs
    ):
        super(FulfillmentInternalServerErrorResponseError, self).__init__(**kwargs)
        self.code = code
        self.message = message


class Operation(msrest.serialization.Model):
    """Operation.

    :param id:
    :type id: str
    :param activity_id:
    :type activity_id: str
    :param subscription_id:
    :type subscription_id: str
    :param offer_id:
    :type offer_id: str
    :param publisher_id:
    :type publisher_id: str
    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: int
    :param action:  Possible values include: "Unsubscribe", "ChangePlan", "ChangeQuantity",
     "Suspend", "Reinstate".
    :type action: str or ~microsoft.marketplace.saas.models.OperationActionEnum
    :param time_stamp:
    :type time_stamp: ~datetime.datetime
    :param status:  Possible values include: "NotStarted", "InProgress", "Succeeded", "Failed",
     "Conflict".
    :type status: str or ~microsoft.marketplace.saas.models.OperationStatusEnum
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'activity_id': {'key': 'activityId', 'type': 'str'},
        'subscription_id': {'key': 'subscriptionId', 'type': 'str'},
        'offer_id': {'key': 'offerId', 'type': 'str'},
        'publisher_id': {'key': 'publisherId', 'type': 'str'},
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'int'},
        'action': {'key': 'action', 'type': 'str'},
        'time_stamp': {'key': 'timeStamp', 'type': 'iso-8601'},
        'status': {'key': 'status', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        activity_id: Optional[str] = None,
        subscription_id: Optional[str] = None,
        offer_id: Optional[str] = None,
        publisher_id: Optional[str] = None,
        plan_id: Optional[str] = None,
        quantity: Optional[int] = None,
        action: Optional[Union[str, "OperationActionEnum"]] = None,
        time_stamp: Optional[datetime.datetime] = None,
        status: Optional[Union[str, "OperationStatusEnum"]] = None,
        **kwargs
    ):
        super(Operation, self).__init__(**kwargs)
        self.id = id
        self.activity_id = activity_id
        self.subscription_id = subscription_id
        self.offer_id = offer_id
        self.publisher_id = publisher_id
        self.plan_id = plan_id
        self.quantity = quantity
        self.action = action
        self.time_stamp = time_stamp
        self.status = status


class OperationList(msrest.serialization.Model):
    """OperationList.

    :param operations:
    :type operations: list[~microsoft.marketplace.saas.models.Operation]
    """

    _attribute_map = {
        'operations': {'key': 'operations', 'type': '[Operation]'},
    }

    def __init__(
        self,
        *,
        operations: Optional[List["Operation"]] = None,
        **kwargs
    ):
        super(OperationList, self).__init__(**kwargs)
        self.operations = operations


class Plan(msrest.serialization.Model):
    """Plan.

    :param plan_id:
    :type plan_id: str
    :param display_name:
    :type display_name: str
    :param is_private:
    :type is_private: bool
    """

    _attribute_map = {
        'plan_id': {'key': 'planId', 'type': 'str'},
        'display_name': {'key': 'displayName', 'type': 'str'},
        'is_private': {'key': 'isPrivate', 'type': 'bool'},
    }

    def __init__(
        self,
        *,
        plan_id: Optional[str] = None,
        display_name: Optional[str] = None,
        is_private: Optional[bool] = None,
        **kwargs
    ):
        super(Plan, self).__init__(**kwargs)
        self.plan_id = plan_id
        self.display_name = display_name
        self.is_private = is_private


class ResolvedSubscription(msrest.serialization.Model):
    """Summary of the subscription.

    :param id:
    :type id: str
    :param subscription_name:
    :type subscription_name: str
    :param offer_id:
    :type offer_id: str
    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: long
    :param subscription:
    :type subscription: ~microsoft.marketplace.saas.models.Subscription
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'subscription_name': {'key': 'subscriptionName', 'type': 'str'},
        'offer_id': {'key': 'offerId', 'type': 'str'},
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'long'},
        'subscription': {'key': 'subscription', 'type': 'Subscription'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        subscription_name: Optional[str] = None,
        offer_id: Optional[str] = None,
        plan_id: Optional[str] = None,
        quantity: Optional[int] = None,
        subscription: Optional["Subscription"] = None,
        **kwargs
    ):
        super(ResolvedSubscription, self).__init__(**kwargs)
        self.id = id
        self.subscription_name = subscription_name
        self.offer_id = offer_id
        self.plan_id = plan_id
        self.quantity = quantity
        self.subscription = subscription


class SubscriberPlan(msrest.serialization.Model):
    """SubscriberPlan.

    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: long
    """

    _attribute_map = {
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'long'},
    }

    def __init__(
        self,
        *,
        plan_id: Optional[str] = None,
        quantity: Optional[int] = None,
        **kwargs
    ):
        super(SubscriberPlan, self).__init__(**kwargs)
        self.plan_id = plan_id
        self.quantity = quantity


class Subscription(msrest.serialization.Model):
    """Subscription.

    :param id:
    :type id: str
    :param publisher_id:
    :type publisher_id: str
    :param offer_id:
    :type offer_id: str
    :param name:
    :type name: str
    :param saas_subscription_status: Indicates the status of the operation. Possible values
     include: "NotStarted", "PendingFulfillmentStart", "Subscribed", "Suspended", "Unsubscribed".
    :type saas_subscription_status: str or
     ~microsoft.marketplace.saas.models.SubscriptionStatusEnum
    :param beneficiary:
    :type beneficiary: ~microsoft.marketplace.saas.models.AadIdentifier
    :param purchaser:
    :type purchaser: ~microsoft.marketplace.saas.models.AadIdentifier
    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: int
    :param term:
    :type term: ~microsoft.marketplace.saas.models.SubscriptionTerm
    :param is_test: Indicating whether the current subscription is a test asset.
    :type is_test: bool
    :param is_free_trial: true - the customer subscription is currently in free trial, false - the
     customer subscription is not currently in free trial.(optional field - default false).
    :type is_free_trial: bool
    :param allowed_customer_operations:
    :type allowed_customer_operations: list[str or
     ~microsoft.marketplace.saas.models.AllowedCustomerOperationsEnum]
    :param session_id:
    :type session_id: str
    :param fulfillment_id:
    :type fulfillment_id: str
    :param store_front:
    :type store_front: str
    :param session_mode: Dry Run indicates all transactions run as Test-Mode in the commerce stack.
     Possible values include: "None", "DryRun".
    :type session_mode: str or ~microsoft.marketplace.saas.models.SessionModeEnum
    :param sandbox_type: Possible Values are None, Csp (Csp sandbox purchase). Possible values
     include: "None", "Csp".
    :type sandbox_type: str or ~microsoft.marketplace.saas.models.SandboxTypeEnum
    """

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'publisher_id': {'key': 'publisherId', 'type': 'str'},
        'offer_id': {'key': 'offerId', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'saas_subscription_status': {'key': 'saasSubscriptionStatus', 'type': 'str'},
        'beneficiary': {'key': 'beneficiary', 'type': 'AadIdentifier'},
        'purchaser': {'key': 'purchaser', 'type': 'AadIdentifier'},
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'int'},
        'term': {'key': 'term', 'type': 'SubscriptionTerm'},
        'is_test': {'key': 'isTest', 'type': 'bool'},
        'is_free_trial': {'key': 'isFreeTrial', 'type': 'bool'},
        'allowed_customer_operations': {'key': 'allowedCustomerOperations', 'type': '[str]'},
        'session_id': {'key': 'sessionId', 'type': 'str'},
        'fulfillment_id': {'key': 'fulfillmentId', 'type': 'str'},
        'store_front': {'key': 'storeFront', 'type': 'str'},
        'session_mode': {'key': 'sessionMode', 'type': 'str'},
        'sandbox_type': {'key': 'sandboxType', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        id: Optional[str] = None,
        publisher_id: Optional[str] = None,
        offer_id: Optional[str] = None,
        name: Optional[str] = None,
        saas_subscription_status: Optional[Union[str, "SubscriptionStatusEnum"]] = None,
        beneficiary: Optional["AadIdentifier"] = None,
        purchaser: Optional["AadIdentifier"] = None,
        plan_id: Optional[str] = None,
        quantity: Optional[int] = None,
        term: Optional["SubscriptionTerm"] = None,
        is_test: Optional[bool] = None,
        is_free_trial: Optional[bool] = None,
        allowed_customer_operations: Optional[List[Union[str, "AllowedCustomerOperationsEnum"]]] = None,
        session_id: Optional[str] = None,
        fulfillment_id: Optional[str] = None,
        store_front: Optional[str] = None,
        session_mode: Optional[Union[str, "SessionModeEnum"]] = None,
        sandbox_type: Optional[Union[str, "SandboxTypeEnum"]] = None,
        **kwargs
    ):
        super(Subscription, self).__init__(**kwargs)
        self.id = id
        self.publisher_id = publisher_id
        self.offer_id = offer_id
        self.name = name
        self.saas_subscription_status = saas_subscription_status
        self.beneficiary = beneficiary
        self.purchaser = purchaser
        self.plan_id = plan_id
        self.quantity = quantity
        self.term = term
        self.is_test = is_test
        self.is_free_trial = is_free_trial
        self.allowed_customer_operations = allowed_customer_operations
        self.session_id = session_id
        self.fulfillment_id = fulfillment_id
        self.store_front = store_front
        self.session_mode = session_mode
        self.sandbox_type = sandbox_type


class SubscriptionPlans(msrest.serialization.Model):
    """SubscriptionPlans.

    :param plans:
    :type plans: list[~microsoft.marketplace.saas.models.Plan]
    """

    _attribute_map = {
        'plans': {'key': 'plans', 'type': '[Plan]'},
    }

    def __init__(
        self,
        *,
        plans: Optional[List["Plan"]] = None,
        **kwargs
    ):
        super(SubscriptionPlans, self).__init__(**kwargs)
        self.plans = plans


class SubscriptionsResponse(msrest.serialization.Model):
    """SubscriptionsResponse.

    :param subscriptions:
    :type subscriptions: list[~microsoft.marketplace.saas.models.Subscription]
    :param next_link: Link to get the next set of subscriptions.
    :type next_link: str
    """

    _attribute_map = {
        'subscriptions': {'key': 'subscriptions', 'type': '[Subscription]'},
        'next_link': {'key': '@nextLink', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        subscriptions: Optional[List["Subscription"]] = None,
        next_link: Optional[str] = None,
        **kwargs
    ):
        super(SubscriptionsResponse, self).__init__(**kwargs)
        self.subscriptions = subscriptions
        self.next_link = next_link


class SubscriptionTerm(msrest.serialization.Model):
    """SubscriptionTerm.

    :param start_date:
    :type start_date: ~datetime.datetime
    :param end_date:
    :type end_date: ~datetime.datetime
    """

    _attribute_map = {
        'start_date': {'key': 'startDate', 'type': 'iso-8601'},
        'end_date': {'key': 'endDate', 'type': 'iso-8601'},
    }

    def __init__(
        self,
        *,
        start_date: Optional[datetime.datetime] = None,
        end_date: Optional[datetime.datetime] = None,
        **kwargs
    ):
        super(SubscriptionTerm, self).__init__(**kwargs)
        self.start_date = start_date
        self.end_date = end_date


class UpdateOperation(msrest.serialization.Model):
    """UpdateOperation.

    :param plan_id:
    :type plan_id: str
    :param quantity:
    :type quantity: long
    :param status:  Possible values include: "Success", "Failure".
    :type status: str or ~microsoft.marketplace.saas.models.UpdateOperationStatusEnum
    """

    _attribute_map = {
        'plan_id': {'key': 'planId', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'long'},
        'status': {'key': 'status', 'type': 'str'},
    }

    def __init__(
        self,
        *,
        plan_id: Optional[str] = None,
        quantity: Optional[int] = None,
        status: Optional[Union[str, "UpdateOperationStatusEnum"]] = None,
        **kwargs
    ):
        super(UpdateOperation, self).__init__(**kwargs)
        self.plan_id = plan_id
        self.quantity = quantity
        self.status = status
